/*
 * SymbolFeatures.h
 *
 *  Created on: Jun 19, 2014
 *      Author: Jan Travnicek
 */

#ifndef SYMBOL_FEATURES_H_
#define SYMBOL_FEATURES_H_

#include <primitive/Unsigned.h>
#include "Symbol.h"

namespace alphabet {

enum class FEATURES {
	LABELED,
	BLANK,
	BOTTOM,
	END,
	RANKED,
	BAR,
	VARIABLES_BAR,
	SUBTREE_WILDCARD,
	SYMBOL_SET_SYMBOL,
	SYMBOL_PAIR_SYMBOL,
	UNIQUE_SYMBOL,
	START
};

class Symbol;
class SymbolBase;

class LabeledSymbol;
class BlankSymbol;
class BottomOfTheStackSymbol;
class EndSymbol;
class StartSymbol;
template < class SymbolType = Symbol, class RankType = primitive::Unsigned >
class RankedSymbol;
class BarSymbol;
class VariablesBarSymbol;
class SubtreeWildcardSymbol;
class NonlinearVariableSymbol;
class SymbolPairSymbol;
class SymbolSetSymbol;
class UniqueSymbol;

} /* namespace alphabet */

#endif /* SYMBOL_FEATURES_H_ */
