/*
 * AutomatonFromXMLParser.cpp
 *
 *  Created on: Oct 12, 2013
 *      Author: Jan Travnicek
 */

#include "AutomatonFromXMLParser.h"
#include <sax/ParserException.h>
#include "Shift.h"
#include "../../regexp/RegExp.h"

namespace automaton {

Shift AutomatonFromXMLParser::parseTransitionShift ( std::deque < sax::Token >::iterator & input ) {
	Shift shift;

	sax::FromXMLParserHelper::popToken ( input, sax::Token::TokenType::START_ELEMENT, "shift" );

	if ( sax::FromXMLParserHelper::isToken ( input, sax::Token::TokenType::CHARACTER, "left" ) )
		shift = Shift::LEFT;
	else if ( sax::FromXMLParserHelper::isToken ( input, sax::Token::TokenType::CHARACTER, "right" ) )
		shift = Shift::RIGHT;
	else if ( sax::FromXMLParserHelper::isToken ( input, sax::Token::TokenType::CHARACTER, "none" ) )
		shift = Shift::NONE;
	else
		throw sax::ParserException ( sax::Token ( "", sax::Token::TokenType::CHARACTER ), * input );

	++input;
	sax::FromXMLParserHelper::popToken ( input, sax::Token::TokenType::END_ELEMENT, "shift" );

	return shift;
}

regexp::RegExp AutomatonFromXMLParser::parseTransitionInputRegexp ( std::deque < sax::Token >::iterator & input ) {
	sax::FromXMLParserHelper::popToken ( input, sax::Token::TokenType::START_ELEMENT, "input" );
	regexp::RegExp result ( alib::xmlApi < regexp::RegExp >::parse ( input ) );
	sax::FromXMLParserHelper::popToken ( input, sax::Token::TokenType::END_ELEMENT, "input" );

	return result;
}

} /* namespace automaton */
