/*
 * AutomatonToXMLComposer.cpp
 *
 *  Created on: Nov 11, 2013
 *      Author: Jan Travnicek
 */

#include "AutomatonToXMLComposer.h"

#include "Shift.h"
#include "../../regexp/RegExp.h"

namespace automaton {

void AutomatonToXMLComposer::composeTransitionInputRegexp(std::deque<sax::Token>& out, const regexp::RegExp& regexp) {
	out.emplace_back("input", sax::Token::TokenType::START_ELEMENT);
	alib::xmlApi<regexp::RegExp>::compose(out, regexp);
	out.emplace_back("input", sax::Token::TokenType::END_ELEMENT);
}

void AutomatonToXMLComposer::composeTransitionShift(std::deque<sax::Token>& out, Shift shift) {
	out.emplace_back("shift", sax::Token::TokenType::START_ELEMENT);
	out.emplace_back(SHIFT_NAMES [shiftToInt(shift)], sax::Token::TokenType::CHARACTER);
	out.emplace_back("shift", sax::Token::TokenType::END_ELEMENT);
}

} /* namespace automaton */

