/*
 * GrammarFeatures.h
 *
 *  Created on: Jun 19, 2014
 *      Author: Jan Travnicek
 */

#ifndef GRAMMAR_FEATURES_H_
#define GRAMMAR_FEATURES_H_

#include <alphabet/Symbol.h>

namespace grammar {

enum class FEATURES {
	LEFT_LG,
	LEFT_RG,
	RIGHT_LG,
	RIGHT_RG,
	LG,
	CFG,
	EPSILON_FREE_CFG,
	CNF,
	GNF,
	CSG,
	NON_CONTRACTING_GRAMMAR,
	CONTEXT_PRESERVING_UNRESTRICTED_GRAMMAR,
	UNRESTRICTED_GRAMMAR
};

class Grammar;
class GrammarBase;

template<class SymbolType = typename alphabet::Symbol >
class LeftLG;
template<class SymbolType = typename alphabet::Symbol >
class LeftRG;
template<class SymbolType = typename alphabet::Symbol >
class RightLG;
template<class SymbolType = typename alphabet::Symbol >
class RightRG;
template<class SymbolType = typename alphabet::Symbol >
class LG;
template<class SymbolType = typename alphabet::Symbol >
class CFG;
template<class SymbolType = typename alphabet::Symbol >
class EpsilonFreeCFG;
template<class SymbolType = typename alphabet::Symbol >
class CNF;
template<class SymbolType = typename alphabet::Symbol >
class GNF;
template<class SymbolType = typename alphabet::Symbol >
class CSG;
template<class SymbolType = typename alphabet::Symbol >
class NonContractingGrammar;
template<class SymbolType = typename alphabet::Symbol >
class ContextPreservingUnrestrictedGrammar;
template<class SymbolType = typename alphabet::Symbol >
class UnrestrictedGrammar;

} /* namespace grammar */

#endif /* GRAMMAR_FEATURES_H_ */
