#ifndef RTE_TO_XML_COMPOSER_H_
#define RTE_TO_XML_COMPOSER_H_

#include "../RTEFeatures.h"
#include <deque>

#include "../formal/FormalRTEElement.h"
#include <sax/Token.h>
#include <alphabet/ranked_symbol.hpp>

namespace rte {

/**
 * This class contains methods to print XML representation of regular tree expression to the output stream.
 */
class RTEToXMLComposer : public FormalRTEElementVisitor {
public:
	RTEToXMLComposer ( ) { }

	static RTEToXMLComposer RTE_TO_XML_COMPOSER;

	static void composeAlphabet ( std::deque < sax::Token > & out, const std::set < std::ranked_symbol < > > & alphabetF, const std::set < std::ranked_symbol < > > & alphabetK );

private:
	void Visit ( void *, const FormalRTEAlternation & alternation ) const;
	void Visit ( void *, const FormalRTEIteration & iteration ) const;
	void Visit ( void *, const FormalRTESubstitution & concatenation ) const;
	void Visit ( void *, const FormalRTESymbolAlphabet & symbol ) const;
	void Visit ( void *, const FormalRTESymbolSubst & symbol ) const;
	void Visit ( void *, const FormalRTEEmpty & empty ) const;
};

} /* namespace rte */

#endif /* RTE_TO_XML_COMPOSER_H_ */
