#include "FormalRTEElement.h"
#include <typeinfo>

#include "FormalRTEElements.h"

#include "../common/RTEFromXMLParser.h"
#include "../common/RTEToXMLComposer.h"
#include <exception/CommonException.h>

namespace rte {

std::pair < std::set < std::ranked_symbol < > >, std::set < std::ranked_symbol < > > > FormalRTEElement::computeMinimalAlphabets ( ) const {
	std::set < std::ranked_symbol < > > alphabetF;
	std::set < std::ranked_symbol < > > alphabetK;

	computeMinimalAlphabet ( alphabetF, alphabetK );
	return std::make_pair ( std::move ( alphabetF ), std::move ( alphabetK ) );
}

} /* namespace rte */

namespace alib {

std::rvalue_ref < rte::FormalRTEElement > xmlApi < rte::FormalRTEElement >::parse ( std::deque < sax::Token >::iterator & input ) {
	return rte::RTEFromXMLParser::parseFormalRTEElement ( input );
}

bool xmlApi < rte::FormalRTEElement >::first ( const std::deque < sax::Token >::const_iterator & ) {
	throw exception::CommonException ( "Unimplemented" );
}

void xmlApi < rte::FormalRTEElement >::compose ( std::deque < sax::Token > & output, const rte::FormalRTEElement & data ) {
	data.Accept ( ( void * ) & output, rte::RTEToXMLComposer::RTE_TO_XML_COMPOSER );
}

} /* namespace rte */
