#ifndef FORMAL_RTE_SYMBOL_H_
#define FORMAL_RTE_SYMBOL_H_

#include <alphabet/ranked_symbol.hpp>
#include "FormalRTEElement.h"

namespace rte {

/**
 * Represents symbol, abstract class
 */
class FormalRTESymbol : public FormalRTEElement {
protected:
	std::ranked_symbol < > symbol;

public:
	FormalRTESymbol ( std::ranked_symbol < > symbol );

	/**
	 * @copydoc FormalRTEElement::clone() const
	 */
	virtual FormalRTESymbol * clone ( ) const = 0;

	/**
	 * @copydoc FormalRTEElement::plunder() const
	 */
	virtual FormalRTESymbol * plunder ( ) && = 0;

	std::ranked_symbol < > getSymbol ( ) const;
};

} /* namespace rte */

#endif /* FORMAL_RTE_SYMBOL_H_ */
