/*
 * TreeFeatures.h
 *
 *  Created on: Nov 16, 2014
 *      Author: Stepan Plachy
 */

#ifndef TREE_FEATURES_H_
#define TREE_FEATURES_H_

#include <alphabet/Symbol.h>
#include <primitive/Unsigned.h>

namespace tree {

enum class FEATURES {
	RANKED_TREE,
	RANKED_PATTERN,
	RANKED_NONLINEAR_PATTERN,
	PREFIX_RANKED_TREE,
	PREFIX_RANKED_BAR_TREE,
	PREFIX_RANKED_PATTERN,
	PREFIX_RANKED_BAR_PATTERN,
	PREFIX_RANKED_NONLINEAR_PATTERN,
	PREFIX_RANKED_BAR_NONLINEAR_PATTERN,
	UNRANKED_TREE,
	UNRANKED_PATTERN,
	UNRANKED_NONLINEAR_PATTERN
};

class Tree;
class TreeBase;

template < class SymbolType = alphabet::Symbol, class RankType = primitive::Unsigned >
class RankedTree;
template < class SymbolType = alphabet::Symbol, class RankType = primitive::Unsigned >
class RankedPattern;
template < class SymbolType = alphabet::Symbol, class RankType = primitive::Unsigned >
class RankedNonlinearPattern;
template < class SymbolType = alphabet::Symbol, class RankType = primitive::Unsigned >
class PrefixRankedTree;
template < class SymbolType = alphabet::Symbol, class RankType = primitive::Unsigned >
class PrefixRankedBarTree;
template < class SymbolType = alphabet::Symbol, class RankType = primitive::Unsigned >
class PrefixRankedPattern;
template < class SymbolType = alphabet::Symbol, class RankType = primitive::Unsigned >
class PrefixRankedNonlinearPattern;
template < class SymbolType = alphabet::Symbol, class RankType = primitive::Unsigned >
class PrefixRankedBarPattern;
template < class SymbolType = alphabet::Symbol, class RankType = primitive::Unsigned >
class PrefixRankedBarNonlinearPattern;
template < class SymbolType = alphabet::Symbol >
class UnrankedTree;
template < class SymbolType = alphabet::Symbol >
class UnrankedPattern;
template < class SymbolType = alphabet::Symbol >
class UnrankedNonlinearPattern;
template < class SymbolType = alphabet::Symbol >
class PrefixBarTree;

} /* namespace tree */

#endif /* TREE_FEATURES_H_ */
