/*
 * TreeAuxiliary.h
 *
 *  Created on: May 5, 2016
 *      Author: Jan Travnicek
 */

#ifndef TREE_AUXILIARY_H_
#define TREE_AUXILIARY_H_

#include <set>
#include <tree>
#include <alphabet/ranked_symbol.hpp>
#include "../../alphabet/Symbol.h"

namespace tree {

/**
 * Parser used to get tree from XML parsed into list of Tokens.
 */
class TreeAuxiliary {
public:
	static std::set < alphabet::Symbol > unrankSymbols ( const std::set < std::ranked_symbol < > > & alphabet );
	static std::set < std::ranked_symbol < > > computeBars ( const std::set < std::ranked_symbol < > > & alphabet, const alphabet::Symbol & barBase );

	static std::tree < std::ranked_symbol < > > toRankedTree ( const std::tree < alphabet::Symbol > & from );
	static std::tree < alphabet::Symbol > toUnrankedTree ( const std::tree < std::ranked_symbol < > > & from );

};

} /* namespace tree */

#endif /* TREE_AUXILIARY_H_ */
