#include <list>
#include "trimTest.h"

#include "automaton/simplify/Trim.h"

#include "automaton/FSM/DFA.h"

#define CPPUNIT_IMPLY(x, y) CPPUNIT_ASSERT(!(x) || (y))

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION( trimTest, "automaton" );
CPPUNIT_TEST_SUITE_REGISTRATION( trimTest );

void trimTest::setUp() {
}

void trimTest::tearDown() {
}

void trimTest::testTrimAutomaton() {
	automaton::DFA<> automaton(label::labelFrom(1));

	automaton.addState(label::labelFrom(1));
	automaton.addState(label::labelFrom(2));
	automaton.addState(label::labelFrom(3));
	automaton.addInputSymbol(alphabet::symbolFrom("a"));
	automaton.addInputSymbol(alphabet::symbolFrom("b"));

	automaton.addTransition(label::labelFrom(1), alphabet::symbolFrom("a"), label::labelFrom(2));
	automaton.addTransition(label::labelFrom(2), alphabet::symbolFrom("b"), label::labelFrom(1));
	automaton.addTransition(label::labelFrom(3), alphabet::symbolFrom("b"), label::labelFrom(1));

	automaton.addFinalState(label::labelFrom(1));

	automaton::DFA<> trimed = automaton::simplify::Trim::trim(automaton);

	CPPUNIT_ASSERT(trimed.getStates().size() == 2);
}
