/*
 * RegExpFromStringParser.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef REG_EXP_FROM_STRING_PARSER_H_
#define REG_EXP_FROM_STRING_PARSER_H_

#include "regexp/RegExpFeatures.h"
#include "RegExpFromStringLexer.h"

#include <set>
#include <memory>

namespace regexp {

class RegExpFromStringParser {
	static std::rvalue_ref < UnboundedRegExpElement > alternation(std::istream& input);
	static std::rvalue_ref < UnboundedRegExpElement > alternationCont(std::istream& input, std::rvalue_ref < UnboundedRegExpElement > left);
	static std::rvalue_ref < UnboundedRegExpElement > alternationContCont(std::istream& input, UnboundedRegExpAlternation left);

	static std::rvalue_ref < UnboundedRegExpElement > concatenation(std::istream& input);
	static std::rvalue_ref < UnboundedRegExpElement > concatenationCont(std::istream& input, std::rvalue_ref < UnboundedRegExpElement > left);
	static std::rvalue_ref < UnboundedRegExpElement > concatenationContCont(std::istream& input, UnboundedRegExpConcatenation left);

	static std::rvalue_ref < UnboundedRegExpElement > factor(std::istream& input);
	static std::rvalue_ref < UnboundedRegExpElement > star(std::istream& input, UnboundedRegExpElement && elem);

public:
	static RegExp parseRegExp(std::istream& input);
	static RegExp parseRegExp(std::istream& input, const std::set<FEATURES>& features);
};

} /* namespace regexp */

#endif /* REG_EXP_FROM_STRING_PARSER_H_ */
